/* 
    Nordic Solar Sensor Beacon re worked without the twi interface
    It is smashed together from hal_radio.c and sensor_beacon.c.

    NOTE: This code is EXPERIMENTAL! It was a weak attempt to get an operational
    "sorta raw" advertising packet using a configuration I assumed would work.
    This is not "Good Code"- use it for an experiment then make something better.
    Though based on Nordic code they didn't write it , so don't bother them.
    >>>>>> This is just for play, NOT GARANTEED TO WORK AT ALL!!!! <<<<<<

    Use nRF Connect to start a "helloworld" zephyr project (fixup CMakeList.txt
     to build this file)
    
    Call the  do_ble_adv_sensor_beacon() from main and compile. Then hope for the
    best. 

    The m_beacon_pdu_sensor_data_set() function is included if you want to modify
    the data between sends .  This code doesn't actually use it.

    Then imagine this stuff transformed into real threads and such, using the 
    actual nordic ble advertisment functions. 

    I targeted the nrf53840-DK board for this test.
    I add to prj.conf because I think I needed these to get the build to find the
    paths. 
    CONFIG_BT=y
*/
#include <zephyr/bluetooth/bluetooth.h>
#include <zephyr/bluetooth/hci.h>
#include <nrf.h>
// #include <controller/hal/cpu.h>
#include <controller/hal/ccm.h>
#include <hal/nrf_radio.h>
#include <hal/nrf_timer.h>
#include "hal_radio.h"

uint8_t access_address[4] = {0xD6, 0xBE, 0x89, 0x8E};
uint8_t seed[3] = {0x55, 0x55, 0x55};


static uint8_t m_adv_pdu[40];               /* The RAM representation of the advertising PDU. */




/**@brief The maximum possible length in device discovery mode. */
#define DD_MAX_PAYLOAD_LENGTH         (31 + 6)


/**@brief The default SHORTS configuration. */
#define DEFAULT_RADIO_SHORTS                                             \
(                                                                        \
    (RADIO_SHORTS_READY_START_Enabled << RADIO_SHORTS_READY_START_Pos) | \
    (RADIO_SHORTS_END_DISABLE_Enabled << RADIO_SHORTS_END_DISABLE_Pos)   \
)


/**@brief The default CRC init polynominal. 

   @note Written in little endian but stored in big endian, because the BLE spec. prints
         is in little endian but the HW stores it in big endian. */
#define CRC_POLYNOMIAL_INIT_SETTINGS  ((0x5B << 0) | (0x06 << 8) | (0x00 << 16))

/**@brief This macro converts the given channel index to a freuency
          offset (i.e. offset from 2400 MHz).

  @param index - the channel index to be converted into frequency offset.
  
  @return The frequency offset for the given index. */
#define CHANNEL_IDX_TO_FREQ_OFFS(index) \
    (((index) == 37)?\
        (2)\
        :\
            (((index) == 38)?\
                (26)\
            :\
                (((index) == 39)?\
                    (80)\
                :\
                    ((/*((index) >= 0) &&*/ ((index) <= 10))?\
                        ((index)*2 + 4)\
                    :\
                        ((index)*2 + 6)))))

#define BD_ADDR_OFFS                (3)     /* BLE device address offest of the beacon advertising pdu. */
#define M_BD_ADDR_SIZE              (6)     /* BLE device address size. */


/* Begin - Definitions for beacons with both temperature and pressure. */
#define SINT16_TEMPERATURE_OFFS     (20)    /* The offset of the temperature in the beacon advertising pdu */
#define UINT32_PRESSURE_OFFS        (26)    /* The offset of the pressure in the beacon advertising pdu */
/* End - Definitions for beacons with both temperature and pressure. */

/* Begin - Definitions for beacons with only temperature. */
#define FLOAT32_TEMPERATURE_OFFS    (36)    /* The offset of the temperature in the beacon advertising pdu */
/* End - Definitions for beacons with only temperature. */

/* Sets the sensor data of the sensor beacon PDU.
 */
static void m_beacon_pdu_sensor_data_set(uint8_t * p_beacon_pdu, int32_t *p_temperature, uint32_t *p_pressure)
{
    if ( (p_pressure != NULL)&& (p_temperature != NULL) )
    {
        /* Pressure (Bluetooth standard) is in Pascal with one decimal, so
           multiplying the value by 10. */
        p_beacon_pdu[UINT32_PRESSURE_OFFS    ] = ((*p_pressure * 10)      ) & 0xFF;
        p_beacon_pdu[UINT32_PRESSURE_OFFS + 1] = ((*p_pressure * 10) >>  8) & 0xFF;
        p_beacon_pdu[UINT32_PRESSURE_OFFS + 2] = ((*p_pressure * 10) >> 16) & 0xFF;
        /* The temperature (Bluetooth standard) is in Celsius with two decimals, so
           deviding the value by an additional 10. */
        p_beacon_pdu[SINT16_TEMPERATURE_OFFS    ] = ((*p_temperature / 10)     ) & 0xFF;
        p_beacon_pdu[SINT16_TEMPERATURE_OFFS + 1] = ((*p_temperature / 10) >> 8) & 0xFF;
    }
    else if ( p_temperature != NULL )
    {
        /* The temperature is in Celsius with one decimal, so
           deviding the value by an additional 100. */
        p_beacon_pdu[FLOAT32_TEMPERATURE_OFFS    ] = ((*p_temperature / 100)     ) & 0xFF;
        p_beacon_pdu[FLOAT32_TEMPERATURE_OFFS + 1] = ((*p_temperature / 100) >> 8) & 0xFF;
        p_beacon_pdu[FLOAT32_TEMPERATURE_OFFS + 2] = 0x00;
        p_beacon_pdu[FLOAT32_TEMPERATURE_OFFS + 3] = 0xFF;
    }
}



/* Waits for the next NVIC event.
 */
#ifdef __GNUC__
static void __INLINE cpu_wfe(void)
#else
static void __forceinline cpu_wfe(void)
#endif
{
    __WFE();
    __SEV();
    __WFE();
}

/* ========================================================================= */
void hal_radio_channel_index_set(uint8_t channel_index)
{
    NRF_RADIO->FREQUENCY = CHANNEL_IDX_TO_FREQ_OFFS(channel_index);
    NRF_RADIO->DATAWHITEIV = channel_index;
}

void hal_radio_reset(void)
{
    NVIC_DisableIRQ(RADIO_IRQn);
    
    NRF_RADIO->POWER = RADIO_POWER_POWER_Disabled << RADIO_POWER_POWER_Pos;
    NRF_RADIO->POWER = RADIO_POWER_POWER_Enabled << RADIO_POWER_POWER_Pos;

    NRF_RADIO->SHORTS = DEFAULT_RADIO_SHORTS;
    
    NRF_RADIO->PCNF0 =   (((1UL) << RADIO_PCNF0_S0LEN_Pos) & RADIO_PCNF0_S0LEN_Msk)
                       | (((2UL) << RADIO_PCNF0_S1LEN_Pos) & RADIO_PCNF0_S1LEN_Msk)
                       | (((6UL) << RADIO_PCNF0_LFLEN_Pos) & RADIO_PCNF0_LFLEN_Msk);

    NRF_RADIO->PCNF1 =   (((RADIO_PCNF1_ENDIAN_Little)        << RADIO_PCNF1_ENDIAN_Pos) & RADIO_PCNF1_ENDIAN_Msk)
                       | (((3UL)                              << RADIO_PCNF1_BALEN_Pos)  & RADIO_PCNF1_BALEN_Msk)
                       | (((0UL)                              << RADIO_PCNF1_STATLEN_Pos)& RADIO_PCNF1_STATLEN_Msk)
                       | ((((uint32_t)DD_MAX_PAYLOAD_LENGTH)  << RADIO_PCNF1_MAXLEN_Pos) & RADIO_PCNF1_MAXLEN_Msk)
                       | ((RADIO_PCNF1_WHITEEN_Enabled << RADIO_PCNF1_WHITEEN_Pos) & RADIO_PCNF1_WHITEEN_Msk);
    
    /* The CRC polynomial is fixed, and is set here. */
    /* The CRC initial value may change, and is set by */
    /* higher level modules as needed. */
    NRF_RADIO->CRCPOLY = (uint32_t)CRC_POLYNOMIAL_INIT_SETTINGS;
    NRF_RADIO->CRCCNF = (((RADIO_CRCCNF_SKIPADDR_Skip) << RADIO_CRCCNF_SKIPADDR_Pos) & RADIO_CRCCNF_SKIPADDR_Msk)
                      | (((RADIO_CRCCNF_LEN_Three)      << RADIO_CRCCNF_LEN_Pos)       & RADIO_CRCCNF_LEN_Msk);

    NRF_RADIO->RXADDRESSES  = ( (RADIO_RXADDRESSES_ADDR0_Enabled) << RADIO_RXADDRESSES_ADDR0_Pos);

    NRF_RADIO->MODE    = ((RADIO_MODE_MODE_Ble_1Mbit) << RADIO_MODE_MODE_Pos) & RADIO_MODE_MODE_Msk;

    NRF_RADIO->TIFS = 150;

    NRF_RADIO->PREFIX0 = access_address[3];
    NRF_RADIO->BASE0   = ( (((uint32_t)access_address[2]) << 24) 
                         | (((uint32_t)access_address[1]) << 16)
                         | (((uint32_t)access_address[0]) << 8) );

    NRF_RADIO->CRCINIT = ((uint32_t)seed[0]) | ((uint32_t)seed[1])<<8 | ((uint32_t)seed[2])<<16;

    NRF_RADIO->INTENSET = (RADIO_INTENSET_DISABLED_Enabled << RADIO_INTENSET_DISABLED_Pos);
    NVIC_ClearPendingIRQ(RADIO_IRQn);
}


void hal_radio_send(uint8_t *p_data)
{
    NRF_RADIO->PACKETPTR = (uint32_t)&(p_data[0]);
    NRF_RADIO->EVENTS_DISABLED = 0;
    

    NRF_TIMER0->BITMODE = TIMER_BITMODE_BITMODE_32Bit;
    NRF_TIMER0->PRESCALER = 4; // default 4Mhz clk (16mhz/4)

    // NRF_TIMER0->SHORTS = TIMER_SHORTS_COMPARE0_CLEAR_Msk;
    NRF_TIMER0->SHORTS = TIMER_SHORTS_COMPARE0_STOP_Msk;
    
    NRF_TIMER0->CC[0] = 400000; 

    // this connects the timer to the transmit "GO" button
    NRF_PPI->CH[0].EEP = (uintptr_t)&NRF_TIMER0->EVENTS_COMPARE[0];
    NRF_PPI->CH[0].TEP = (uintptr_t)&NRF_RADIO->TASKS_TXEN;
    NRF_PPI->CHENSET = PPI_CHENSET_CH0_Msk;

    NVIC_ClearPendingIRQ(RADIO_IRQn);

    NRF_TIMER0->TASKS_CLEAR = 1;
    NRF_TIMER0->TASKS_START = 1;

}
/* ========================================================================= */

/* Initializes the beacon advertising PDU.
 */
static void m_beacon_pdu_init(uint8_t * p_beacon_pdu)
{
    p_beacon_pdu[0] = 0x42;
    p_beacon_pdu[1] = 0;
    p_beacon_pdu[2] = 0;
}

/* Sets the BLE address field in the sensor beacon PDU.
 */
static void m_beacon_pdu_bd_addr_default_set(uint8_t * p_beacon_pdu)
{
    static const uint8_t random_bd_addr[M_BD_ADDR_SIZE] = {0xE2, 0xA3, 0x01, 0xE7, 0x61, 0xF7};
    memcpy(&(p_beacon_pdu[3]), &(random_bd_addr[0]), M_BD_ADDR_SIZE);
    
    p_beacon_pdu[1] = (p_beacon_pdu[1] == 0) ? M_BD_ADDR_SIZE : p_beacon_pdu[1];
}

/* Sends an advertising PDU on the given channel index.
 */
static void send_one_packet(uint8_t channel_index)
{
    uint8_t i;
    

    hal_radio_channel_index_set(channel_index);
    hal_radio_send(m_adv_pdu); // yeah... passing a global to a function

    // wait for radio done interrupt
    uint32_t testvalue = 0 ;
    while (testvalue == 0) {
        testvalue = NVIC_GetPendingIRQ(RADIO_IRQn);
    }
    
    for ( i = 0; i < 9; i++ )
    {
        __NOP();
    }
}


/* Handles beacon managing.
 */
static void beacon_handler(void)
{
    NRF_CLOCK->TASKS_HFCLKSTART = 1;
    while (!NRF_CLOCK->EVENTS_HFCLKSTARTED) {
    }

    hal_radio_reset();

    do
    {
        // transmit on each advertising channel

        send_one_packet(37);

        send_one_packet(38);

        send_one_packet(39);

    } while ( 1 );
}  

/* Resets the sensor data of the sensor beacon PDU.
 */
static void m_beacon_pdu_sensor_data_reset(uint8_t * p_beacon_pdu)
{
#if 0

                static const uint8_t beacon_temp_only[31] = 
                {
                    0x02,
                    0x01, 0x04,
                    0x03,
                    0x19, 0x00, 0x03,
                    0x07,
                    0x09, 0x54, 0x65, 0x6D, 0x70, 0x6F, 0x20,
                    0x07,
                    0x03, 0x02, 0x18, 0x09, 0x18, 0x0A, 0x18,
                    0x07,
                    0x16, 0x09, 0x18, 0xA3, 0x70, 0x45, 0x41,
                };
                memcpy(&(p_beacon_pdu[3 + M_BD_ADDR_SIZE]), &(beacon_temp_only[0]), sizeof(beacon_temp_only));
                p_beacon_pdu[1] = M_BD_ADDR_SIZE + sizeof(beacon_temp_only);

#else
    static const uint8_t beacon_temp_pres[21] = 
    {
        0x02,
        0x01, 0x04,
        0x03,
        0x03, 0xE5, 0xFE,
        /* Entry for temperature characteristics. Ref:
            sint16, https://developer.bluetooth.org/gatt/characteristics/Pages/CharacteristicViewer.aspx?u=org.bluetooth.characteristic.temperature.xml */
        0x05,
        0x16, 0x6E, 0x2A, 0x00, 0x00,               
        /* Entry for pressure characteristics. Ref:
            uint32, https://developer.bluetooth.org/gatt/characteristics/Pages/CharacteristicViewer.aspx?u=org.bluetooth.characteristic.pressure.xml */
        0x07,
        0x16, 0x6D, 0x2A, 0x00, 0x00, 0x00, 0x00,   
    };
    memcpy(&(p_beacon_pdu[3 + M_BD_ADDR_SIZE]), &(beacon_temp_pres[0]), sizeof(beacon_temp_pres));
    p_beacon_pdu[1] = M_BD_ADDR_SIZE + sizeof(beacon_temp_pres);
#endif
}


int do_ble_adv_sensor_beacon(void)
{


    m_beacon_pdu_init(&(m_adv_pdu[0]));
    m_beacon_pdu_bd_addr_default_set(&(m_adv_pdu[0]));
    m_beacon_pdu_sensor_data_reset(&(m_adv_pdu[0]));
    
    for (;;)
    {
        beacon_handler();
    }

    return 0;
}


